<template>
  <div>
    <CdxButton weight="quiet" aria-label="Open keyboard shortcuts dialog" @click="open = true">
      <CdxIcon :icon="cdxIconSettings" />
    </CdxButton>
    <CdxDialog
      :open="open"
      title="Audio settings"
      class="shortcuts-content"
      close-button-label="Close"
      aria-label="Close Dialog"
      :primary-action="primaryAction"
      @primary="primaryDialogAction"
      @update:open="(newValue) => (open = newValue)"
    >
      <div class="mb-4">
        <p class="font-medium mb-1">Recording Type</p>
        <CdxSelect
          v-model:selected="currentRecordingType"
          :menu-items="recordingOptions"
          class="w-full"
          @update:selected="handleRecordingTypeChange"
        />
      </div>
      <div class="mb-4">
        <p class="font-medium mb-1">Start Threshold</p>
        <CdxTextInput
          v-model="properties.startThreshold"
          input-type="number"
          placeholder="Start Threshold"
          min="0.02"
          max="0.50"
          step="0.01"
        />
      </div>

      <div class="mb-4">
        <p class="font-medium mb-1">Stop Threshold</p>
        <CdxTextInput
          v-model="properties.stopThreshold"
          input-type="number"
          placeholder="Stop Threshold"
          min="0.01"
          max="0.25"
          step="0.01"
        />
      </div>

      <div class="mb-4">
        <p class="font-medium mb-1">Stop Duration</p>
        <CdxTextInput
          v-model="properties.stopDuration"
          input-type="number"
          placeholder="Stop Duration"
          :min="stopDurationConfig.min"
          :max="stopDurationConfig.max"
          :step="stopDurationConfig.step"
        />
      </div>

      <div class="mb-4">
        <p class="font-medium mb-1">Margin Before</p>
        <CdxTextInput
          v-model="properties.marginBefore"
          input-type="number"
          placeholder="Margin Before"
          min="0.10"
          max="3"
          step="0.01"
        />
      </div>

      <div class="mb-4">
        <p class="font-medium mb-1">Margin After</p>
        <CdxTextInput
          v-model="properties.marginAfter"
          input-type="number"
          placeholder="Margin After"
          min="0.10"
          max="3"
          step="0.01"
        />
      </div>

      <div class="mb-4">
        <p class="font-medium mb-1">Saturation Threshold</p>
        <CdxTextInput
          v-model="properties.saturationThreshold"
          input-type="number"
          placeholder="Saturation Threshold"
          min="0.5"
          max="0.99"
          step="0.01"
        />
      </div>
    </CdxDialog>
  </div>
</template>

<script setup>
import { CdxButton, CdxDialog, CdxIcon, CdxTextInput, CdxSelect } from '@wikimedia/codex'
import { cdxIconSettings } from '@wikimedia/codex-icons'
import { ref, defineProps, defineEmits, defineExpose } from 'vue'
import { useRecordWizardStore } from '@/stores/recordwizard'

const props = defineProps({
  properties: Object,
})

const store = useRecordWizardStore()

const emit = defineEmits(['reInitializeRecorder'])

const primaryAction = {
  label: 'Save',
  actionType: 'progressive',
}

const primaryDialogAction = () => {
  emit('reInitializeRecorder')
  open.value = false
}

const stopDurationConfig = ref({
  min: '0.10',
  max: '8',
  step: '0.01',
})

const currentRecordingType = ref(store.items.length ? store.items[0].type : 'word')
const handleRecordingTypeChange = (value) => {
  let init, min, max, step
  if (value === 'word') {
    init = 0.3
    min = 0.1
    max = 8
    step = 0.1
  } else if (value === 'sentence') {
    init = 2.0
    min = 3.0
    max = 8
    step = 1.0
  } else if (value === 'poem') {
    init = 2.0
    min = 5.0
    max = 12
    step = 1.0
  }
  stopDurationConfig.value = { min, max, step }
  props.properties.stopDuration = init
  currentRecordingType.value = value
}

defineExpose({ handleRecordingTypeChange })

const recordingOptions = [
  {
    label: 'Words',
    value: 'word',
  },
  {
    label: 'Sentences',
    value: 'sentence',
  },
  {
    label: 'Poems',
    value: 'poem',
  },
]

const open = ref(false)
</script>
